;
; OLION80 for PC-6001mk2SR/PC-6601SR
;
; disk ipl 2
;
	relaxed on

	IFDEF V2
OFFSET		EQU	$0000
	ELSEIF
OFFSET		EQU	$0077		; $90a2 - $902b
	ENDIF


CNTSEC	EQU	$ae03-OFFSET
CNTMIN	EQU	$ae04-OFFSET
SON	EQU	$9b02-OFFSET
SOFF	EQU	$9b12-OFFSET


	org	$f000

	jp	LOADMAIN	; $F000
	jp	LOADSAVE	; $F003
	jp	LOADHEAD	; $F006
	jp	SCLOADSAVE	; $F009
	jp	SCLOADSAVEINIT	; $F00C

KEYBUF:		db	$00	; $F00F
GAMEKEYBUF:	db	$00	; $F010
VSYNCBUF:	db	$00	; $F011
STOPFLAG:	db	$00	; $F012
CNTVSYNC:	db	$00	; $F013
TIMERCNT:	db	$00	; $F014


;
; CvOǂݍ
;
LOADMAIN:
	call	BASICENB

	xor	a
	ld	($ed66),a	; hCuԍ
	ld	de,$7000	; i[擪AhX
	ld	bc,$0101	; gbNԍ01H`07H
.rd1:	push	bc
	push	de
	ld	a,$01		; ZN^
	or	a		; Cflag=0,Zflag=0ifBXN̓́j
	call	$0198
	pop	de
	pop	bc
	inc	d
	inc	c
	ld	a,c
	cp	$11		; ZN^ԍ=01H`10H
	jr	nz,.rd1
	ld	c,$01
	inc	b
	ld	a,b
	cp	$08		; gbNԍ=02H`07H
	jr	c,.rd1

		; 荞ݐݒ
	di

	ld	hl,INTTABLE
	ld	de,$e600
	ld	bc,$0030
	ldir			; 荞݃e[u

	ld	a,$7f
	out	($f6),a		; ^C}荞݊ԊuA2ms
	ld	a,$f6
	out	($b0),a		; ^C}荞ON

	call	BASICDIS

	ld	de,$0000
	ld	hl,RSTTABLE
	ld	bc,$0040
	ldir			; RST00H`RST38Hݒ肷

	ld	sp,$0000

	jp	$7000		; C


;
; BASIC-ROML
;
BASICENB:
	di
	ld	a,$f8		; 0x0000-0x7FFF̓ǂݍ݂BASIC-ROM
	out	($60),a
	ld	a,$fa
	out	($61),a
	ld	a,$fc
	out	($62),a
	ld	a,$fe
	out	($63),a
	ld	a,$ff
	out	($fa),a		; 荞݂SĖɂ
	ei

	ret

;
; BASIC-ROM
;
BASICDIS:
	di
	xor	a		; 0x0000-0x7FFF RAM
	out	($60),a	
	ld	a,$02
	out	($61),a	
	ld	a,$04
	out	($62),a	
	ld	a,$06
	out	($63),a	
	ld	a,$ea
	out	($fa),a		; VSYNC(4)ATIMER(2)Asub-CPU(0)̊荞݂L
	ei

	ret


;
; ʃf[^[h^Z[u
;
; AregF0x00=[hAȊO=Z[u
; BregFgbNԍ
;
; RETURN:G[ACflag=1
;
LOADSAVE:
	or	a
	ld	a,$00		; nop
	jr	z,.fset
	ld	a,$37		; scf
.fset:	ld	(.flag),a

	call	BASICENB

		; t@Cǂݍ
	xor	a
	ld	($ed66),a	; hCuԍ
	ld	de,$c200	; i[擪AhX
	ld	c,$03		; ZN^ԍ#03
.rd1:	push	bc
	push	de
	ld	a,$01		; ZN^
	or	a		; Cflag=0,Zflag=0ifBXN̓́j
.flag:	nop
	call	$0198
	jr	c,.err
	pop	de
	pop	bc
	inc	d
	inc	c
	ld	a,c
	cp	$11		; ZN^ԍ=#03`#16
	jr	nz,.rd1
	or	a

.end:	push	af
	call	BASICDIS
	pop	af
	ret

.err:
	pop	de
	pop	bc
	jr	.end


;
; ʃf[^̃wb_̃[h
;
; BregFgbNԍ
;
; RETURN:G[ACflag=1
;
LOADHEAD:
	call	BASICENB

		; t@Cǂݍ
	xor	a
	ld	($ed66),a	; hCuԍ
	ld	de,$f300	; i[擪AhX
	ld	c,$03		; ZN^ԍ#03
	ld	a,$01		; ZN^
	or	a		; Cflag=0,Zflag=0ifBXN̓́j
	call	$0198

	push	af
	call	BASICDIS
	pop	af

	ret


;
; a薼OƃXRÃ[h^Z[u
;
; AregF0x00=[hAȊO=Z[u
; BregFgbNԍ
;
SCLOADSAVEINIT:
	ld	c,$02		; ZN^ԍ#02
	jr	SCLOADSAVE.next
SCLOADSAVE:
	ld	c,$01		; ZN^ԍ#01
.next:	or	a
	ld	a,$00		; nop
	jr	z,.fset
	ld	a,$37		; scf
.fset:	ld	(.flag),a

	call	BASICENB

		; t@C
	xor	a
	ld	($ed66),a	; hCuԍ
	ld	de,$f300	; i[擪AhX
	ld	a,$01		; ZN^
	or	a		; Cflag=0,Zflag=0ifBXN̓́j
.flag:	nop
	call	$0198

	push	af
	call	BASICDIS
	pop	af

	ret



;
; BEEP̔
;
SOUND:
	push	af
	ld	a,$08
	out	($a0),a
	pop	af

	bit	5,a		; SOUUND ONA'1'
	ld	a,$0f
	jr	nz,.on
	xor	a
.on:	out	($a1),a

	ret

;
; 荞ݏI[iȂj
;
INTDT0:
	ei
	ret

;
; 荞ݏI[if[^PoCgM{Ȃj
;
INTDT1:
	push	af
	call	GETSUBCPU
	pop	af
	ei
	ret

;
; 荞ݏI[if[^ToCgM{Ȃj
;
INTDT5:
	push	af
	call	GETSUBCPU
	call	GETSUBCPU
	call	GETSUBCPU
	call	GETSUBCPU
	call	GETSUBCPU
	pop	af
	ei
	ret

;
; 荞ݏI[if[^moCgM{Ȃj
;
INTDTN:
	push	af
	call	GETSUBCPU
.loop:	push	af
	call	GETSUBCPU
	pop	af
	inc	a
	jr	nz,.loop
	pop	af
	ei
	ret

;
; Q[L[荞
;
GAMEKEYINT:
	push	af
	call	GETSUBCPU
	ld	(GAMEKEYBUF),a
	pop	af
	ei
	ret


;
; ^C}荞
;
TIMERINT:
	push	af
	ld	a,(TIMERCNT)
	inc	a
	ld	(TIMERCNT),a
	and	$07
	jr	nz,.wait
	ld	a,$06
	call	SETSUBCPU	; Q[L[̏񑗐Mv
.wait:	pop	af
	ei
	ret

;
; VSYNC荞
;
VSYNC:
	push	af
	ld	a,(VSYNCBUF)
	cpl
	ld	(VSYNCBUF),a

	ld	a,(STOPFLAG)
	or	a
	jr	nz,.end

	ld	a,(CNTVSYNC)
	inc	a
	ld	(CNTVSYNC),a
	cp	60
	jr	c,.end

	xor	a
	ld	(CNTVSYNC),a

	ld	a,(CNTSEC)
	inc	a
	daa
	ld	(CNTSEC),a
	cp	$60
	jr	c,.end

	xor	a
	ld	(CNTSEC),a

	ld	a,(CNTMIN)
	inc	a
	cp	11
	jr	nc,.end

	ld	(CNTMIN),a

.end:	pop	af
	ei
	ret

;
; TuCPUPoCgf[^M
;
; RETFAreg=Mf[^
;
GETSUBCPU:
	ld	a,$0c
	out	($93),a
.loop:
	in	a,($92)
	and	$20
	jr	z,.loop
	ld	a,$0d
	out	($93),a
	in	a,($90)
	ret

;
; TuCPUւPoCgf[^𑗐M
;
; Areg=Mf[^
;
SETSUBCPU:
	push	af
	ld	a,$08
	out	($93),a
.loop:
	in	a,($92)
	and	$80
	jr	z,.loop
	ld	a,$09
	out	($93),a
	pop	af
	out	($90),a
	ret

;
; ʏL[͊荞
;
; GRAPH+L[̏ꍇ́AASCIIR[h
; t@NVL[̏ꍇ́A0xf0`0xf9
; STOPL[̏ꍇ́A0xfa
; ʏL[́AASCIIR[h
;
KEYINT:
	push	af
	call	GETSUBCPU

	or	a
	jr	z,.nodt
	bit	7,a
	jr	nz,.nodt

	bit	6,a
	jr	z,.end
	and	$df
	jr	.end

.nodt:	ld	a,$00
.end:	ld	(KEYBUF),a

	pop	af
	ei
	ret

;
; GRAPH+L[͊荞
;
; GRAPH+L[̏ꍇ́AASCIIR[h
; t@NVL[̏ꍇ́A0xf0`0xf9
; STOPL[̏ꍇ́A0xfa
; ʏL[́AASCIIR[h
;
KEYGRINT:
	push	af
	call	GETSUBCPU

	or	a
	jr	z,.nodt
	bit	7,a
	jr	nz,.end

.nodt:	ld	a,$00
.end:	ld	(KEYBUF),a
	pop	af
	ei
	ret



;
; 荞݃e[u
;
INTTABLE:
	dw	INTDT0		; 00 ; gp
	dw	KEYINT		; 02 ; L[
	dw	INTDT0		; 04 ; RS232C
	dw	TIMERINT	; 06 ; 2ms^C}
	dw	INTDT1		; 08 ; JZbgREAD
	dw	INTDT0		; 0A ; gp
	dw	INTDT0		; 0C ; gp
	dw	INTDT1		; 0E ; L[(CMT)
	dw	INTDT1		; 10 ; L[(CMT)
	dw	INTDT0		; 12 ; JZbgG[
	dw	KEYGRINT	; 14 ; L[(GRAPH,Func)
	dw	GAMEKEYINT	; 16 ; Q[L[
	dw	INTDTN		; 18 ; TVR
	dw	INTDT5		; 1A ; TIME֘A
	dw	INTDT1		; 1C ; TIME֘A
	dw	INTDT0		; 1E ; gp
	dw	INTDT0		; 20 ; 
	dw	VSYNC		; 22 ; VSYNC
	dw	INTDT0		; 24 ; gp
	dw	INTDT0		; 26 ; gp
	dw	INTDT0		; 28 ; gp
	dw	INTDT0		; 2A ; gp
	dw	INTDT0		; 2C ; gp
	dw	INTDT0		; 2E ; gp


RSTTABLE:
	nop			; RST	00H
	nop
	nop
	nop
	nop
	nop
	nop
	nop

.rst08:	ld	a,(hl)		; RST	08H
	ld	(de),a
	inc	hl
	inc	de
	inc	de
	djnz	.rst08	
	ret

	jp	SOUND		; RST	10H
	nop
	nop
	nop
	nop
	nop

	ldi			; RST	18H
	inc	de
	ret
	nop
	nop
	nop
	nop

	inc	de		; RST	20H
	inc	de
	ret
	nop
	nop
	nop
	nop
	nop

	inc	hl		;RST	28H
	inc	hl
	ret
	nop
	nop
	nop
	nop
	nop

	jp	SOFF		; RST	30H	i~߂j
	nop
	nop
	nop
	nop
	nop

	jp	SON		; RST	38H	i炷j
	nop
	nop
	nop
	nop
	nop


	org	$f2ff
	db	$ff

	end
