;
; OLION80 for PC-6001mk2SR/PC-6601SR
; additional program
;
	relaxed on

	IFDEF V2
OFFSET		EQU	$0000
	ELSEIF
OFFSET		EQU	$0077		; $90a2 - $902b
	ENDIF

MAINLOOP	EQU	$808e
SPACEDETMAIN	EQU	$8389
CPAGEMAIN	EQU	$8a71
PAGE		EQU	$8a8b
VRAM		EQU	$8c1b

ENEMYMAIN	EQU	$9243 - OFFSET
COUT42MAIN1	EQU	$9435 - OFFSET
COUT42MAIN2	EQU	$947f - OFFSET
MOVESHIP	EQU	$95db - OFFSET
AUTOON		EQU	$96dc - OFFSET
AUTOOFF		EQU	$9691 - OFFSET
HREV		EQU	$9727 - OFFSET
VREV		EQU	$972c - OFFSET
SOUNDSW		EQU	$9735 - OFFSET
SPEED		EQU	$9898 - OFFSET
SHOOT		EQU	$9a41 - OFFSET
DISPINVFLAG	EQU	$a0b1 - OFFSET
DISPCRSMAIN1	EQU	$a352 - OFFSET
DISPCRSMAIN2	EQU	$a378 - OFFSET
DISPNAME	EQU	$a9c8 - OFFSET
SCORETABLE	EQU	$aae8 - OFFSET
NAMEENT		EQU	$acd5 - OFFSET
COMM		EQU	$b185 - OFFSET
CALCBOX		EQU	$b839 - OFFSET
BOXDEL		EQU	$b855 - OFFSET
BOXINS		EQU	$b8aa - OFFSET
ENCCOL		EQU	$b906 - OFFSET
ChANGEBLINK	EQU	$ba97 - OFFSET
CHANGECOL1	EQU	$baaf - OFFSET
CHANGECOL2	EQU	$bab4 - OFFSET
GETSHIP		EQU	$bac1 - OFFSET
SCORESHIP	EQU	$bae8 - OFFSET
PUTSHIP		EQU	$bad5 - OFFSET
EXITDEG		EQU	$baf8 - OFFSET
LOADSHIP	EQU	$bafc - OFFSET
SAVESHIP	EQU	$bb06 - OFFSET
BOXMAKE		EQU	$bb12 - OFFSET
BOXNEXT		EQU	$bb51 - OFFSET
INITSHIP	EQU	$bb74 - OFFSET
BOXMOVE		EQU	$bb9d - OFFSET
CURMOVEU	EQU	$bbd0 - OFFSET
CURMOVEL	EQU	$bbea - OFFSET
CURMOVED	EQU	$bc04 - OFFSET
CURMOVER	EQU	$bc16 - OFFSET
BOXCHANGE	EQU	$bc28 - OFFSET
COMEND		EQU	$bc80 - OFFSET
NUMSET		EQU	$bce3 - OFFSET
GETPUTSCORE	EQU	$bcf1 - OFFSET
NUMDEL		EQU	$bd25 - OFFSET
DISPSTR		EQU	$bd32 - OFFSET
DISPBCD		EQU	$bda6 - OFFSET
STRLOADFILE	EQU	$be87 - OFFSET
STRSAVEFILE	EQU	$be99 - OFFSET
BOXNO		EQU	$bf2a - OFFSET
ZEROCHGENB	EQU	$bf2e - OFFSET
BCDNUM		EQU	$bf30 - OFFSET
COMNUM		EQU	$bf32 - OFFSET

SCORE		EQU	$db4e
PORT00		EQU	$db66



LOADSAVE	EQU	$F003
LOADHEAD	EQU	$F006
SCLOADSAVE	EQU	$F009
SCLOADSAVEINIT	EQU	$F00C

KEYBUF		EQU	$F00F
GAMEKEYBUF	EQU	$F010
VSYNCBUF	EQU	$F011
STOPFLAG	EQU	$F012
CNTVSYNC	EQU	$F013
TIMERCNT	EQU	$F014


	org	$7000

	jp	INIT		; $7000
	jp	CPAGE		; $7003
	jp	SPACEDET	; $7006
	jp	COUT42SUB1	; $7009
	jp	COUT42SUB2	; $700C
	jp	ATTCTL		; $700F
	jp	SETWPAT		; $7012
	jp	WARPCLS		; $7015
	jp	WARPCH		; $7018
	jp	VSYNCWAIT	; $701B
	jp	PAUSE		; $701E
	jp	DEMOKEYIN	; $7021
	jp	MAINKEYIN	; $7024
	jp	NAMEIN		; $7027
	jp	DISPCROSS1	; $702A
	jp	DISPCROSS2	; $702D
	jp	ENEMY1		; $7030
	jp	ENEMY2		; $7033
	jp	DISPINV		; $7036
	jp	GETKEY		; $7039
	jp	DEGATT		; $703C
	jp	GETFULLKEY	; $703F
	jp	CHECKSFT	; $7042
	jp	CURMOVE		; $7045
	jp	DEGCOL		; $7048
	jp	DEGCOM		; $704B
	jp	DEGEXCOM	; $704E
	jp	SCORESAVE	; $7051
	jp	DISKPRE		; $7054


	org	$7070

FULKEYDT:	db	$00	; $7070
JOYKEYDT:	db	$00	; $7071
JOYKEYPUSH:	db	$00	; $7072
COUT42CNT:	db	$00	; $7073


	org	$7080

		db	"  LOAD FILE #0   ",$00		; $7080
		db	"  SAVE FILE #0   ",$00		; $7092
STRIOERR:	db	"I/O Err : hit SPC",$00		; $70A4
STRNODATA:	db	"No Data : hit SPC",$00		; $70B6
STROVERWR:	db	"Overwrite? (Y/N) ",$00		; $70C8
STRHICLR	db	"CLEAR SCORE #0   ",$00		; $70DA
STRCLRFILE	db	"Initialize score ",$00		; $70DA


	org	$7100

;
; y[W؂ւ
;
CPAGE:
	di
	ld	a,(PAGE)
	xor	$00		; for debug (xor $10)
	rrca
	rrca
	rrca
	rrca
	push	af
	ld	a,(SYNCENB)
	or	a
	jr	z,.end

	ld	a,$0e
	out	($a0),a
.loop1:	in	a,($a2)		; V  H  T2 T1 -> <- v  ^
	and	$40
	jr	nz,.loop1
.loop2:	in	a,($a2)		; V  H  T2 T1 -> <- v  ^
	and	$40
	jr	z,.loop2

.end:	pop	af
	out	($c9),a
	push	af		; dummy
	pop	af		; dummy
	ei
	ret


;
; ݒ
;
INIT:

	ld	a,$07
	out	($a0),a
	ld	a,$be		; TONE-Âݏo
	out	($a1),a

	ld	a,$01
	out	($a0),a
	ld	a,00		; TONE-Ả
	out	($a1),a

	ld	a,$00
	out	($a0),a
	ld	a,125		; TONE-Ả
	out	($a1),a

	ld	a,$08
	out	($a0),a
	ld	a,$00		; TONE-Ả
	out	($a1),a


		;
		; oł邩̃`FbN
		;
	ld	bc,$0000
	ld	de,$0000

	ld	a,$0e
	out	($a0),a
.loop:	in	a,($a2)
	and	$40		; o

	ld	h,a		; Ԃł͂Ȃ=0x40
	xor	$40		; Ԃ̎=0x40

	or	e
	ld	e,a

	ld	a,h
	or	d
	ld	d,a

	dec	bc
	ld	a,b
	or	c
	jr	nz,.loop

	ld	a,d
	and	e		; ωĂȂA0x00

	ld	(SYNCENB),a	; G~[^A0x00ɂȂ

	ei

		;
		; Jnʂ̕ύX
		;
	ld	a,$00		; Jnʔԍ
	ld	(GAMENO),a

	call	GETKEY
	sub	'0'
	jr	c,.dt_read
	cp	$0a
	jr	nc,.dt_read

	ld	(GAMENO),a

		; ʃf[^̗L̊mF
	ld	a,(GAMENO)
	add	a,$08
	ld	b,a
	call	LOADHEAD

	call	HEADCHECK
	jr	nz,.dt_read

	ld	a,$00
	ld	(GAMENO),a

.dt_read:
		; ʃf[^ǂݍ
	ld	a,(GAMENO)
	add	a,$08
	ld	b,a
	ld	a,$00
	call	LOADSAVE		; ʃf[^[h


		; nCXRAǂݍ
	ld	a,(GAMENO)
	add	a,$08
	ld	b,a
	ld	a,$00
	call	SCLOADSAVE		; nCXRAǂݍ


	ld	hl,$f300
	ld	de,SCORETABLE
	ld	bc,10+16*5
	ldir

	ld	a,(GAMENO)
	ld	(FILENO),a

	ld	hl,$0000
	ld	(SCORE),hl

	jp	MAINLOOP	; C[`


SYNCENB:
	db	$01



;
; 4x2LN^\̃pb`
;
COUT42SUB1:
	di
	ld	(COUTSP+1),sp
	ld	sp,hl
	ex	de,hl

	ld	a,$02
	ld	(COUT42CNT),a

	jp	COUT42MAIN1


COUT42SUB2:
COUTSP:
	ld	sp,$0000	; ld	sp,COUTSP
	ei
	jp	COUT42MAIN2



;
; Agr[g̐ݒi`Ŏw肳j
;
;
; HL:LN^擪AhX
; B:xJԂ
; C:Agr[gf[^
; D:ݒJnXW
; E:ݒXW
;
; attribute control
;

;
; Agr[gϊ
;
; P8 G R B graph 1 0 0 0
;
; P6 graph 0 0 0 1 B G R
;
ATTCTL:
	ld	a,c

	and	$f0
	rlca
	rlca		; B graph 0 0 0 0 G R
	ld	c,$00
	bit	7,a
	jr	z,.blue0
	ld	c,$04
.blue0:	and	$43	; 0 graph 0 0 0 0 G R
	or	c	; 0 graph 0 0 0 B G R
	ld	c,$08
	bit	6,a
	jr	z,.graph
	ld	c,$88
.graph:	and	$07	; 0 0 0 0 0 B G R
	or	c	; graph 0 0 0 1 B G R
	ld	c,a

	inc	hl			; Agr[gAhX

	ld	a,e
	sub	d
	ld	(.ycnt+1),a		; X[v

	add	a,a

	ld	de,160
	neg
	add	a,e			; 160 - X[v
	ld	e,a

	ld	a,c			; Agr[gf[^
	ld	c,b			; Y[v
.loop2:
.ycnt:	ld	b,$00			; X[v

.loop1:	ld	(hl),a
	inc	hl
	inc	hl
	djnz	.loop1

	add	hl,de
	dec	c
	jr	nz,.loop2

	ret

;
; L[f[^ƃWCXeBbNf[^擾
;
GETFULLKEY:
	push	bc

	call	GETKEY
	ld	(FULKEYDT),a

	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	ld	(JOYKEYDT),a
	and	c
	ld	(JOYKEYPUSH),a

	pop	bc
	ret


;
; SHIFTL[Ă邩ǂ̃`FbN
; Ă鎞AZflag=1
;
CHECKSFT:
	ld	a,(JOYKEYDT)
	cpl
	bit	0,a
	ret

;
; ̊g^kAړ
;
CURMOVE:
	ld	a,(JOYKEYPUSH)
	ld	d,a

	bit	3,d
	call	nz,CURMOVED	; 
	bit	2,d
	call	nz,CURMOVEU	; 
	bit	5,d
	call	nz,CURMOVEL	; 
	bit	4,d
	call	nz,CURMOVER	; E

	ret


;
; SPACEL[o
; ꂽAZflag=1
;
SPACEDET:
	push	bc
	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	pop	bc
	cpl
	bit	7,a
	jp	SPACEDETMAIN


;
; PAUSE
;
PAUSE:
	push	bc

	call	GETKEY
	cp	$1b		; ESC
	jr	z,.esc

	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	and	c
	and	$02
	jr	z,.end

.esc:
	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	and	c
	and	$02
	jr	nz,.end

	call	GETKEY
	cp	$1b		; ESC
	jr	nz,.esc

.end:	pop	bc
	ret


;
; fpL[
;
; ESC:ESC܂Œ~
;     ̑̃L[Ɠl
;
; RETURN
; STOPF	Areg <= 0x00	Cflag=1,ZFlag=0
; SPACEF	Areg <= 0x01	Cflag=0
; F10F		Areg <= 0x02	Cflag=0
; ̑̃L[FAreg <= 0x03	Cflag=0
;
DEMOKEYIN:
	push	bc
	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	ld	b,a
	jr	z,.n_stop

		; STOP
	ld	a,$00		;Zflag=0
	scf			;Cflag=1
	ret

.n_stop:
	call	GETKEY
	cp	$f9		; F10
	jr	nz,.n_e

		; F10
	ld	a,$02
	jr	.end

.n_e:
	cp	$1b		; ESC
	jr	z,.esc

	ld	a,b
	and	c
	and	$02
	jr	z,.n_esc

.esc:	
	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	and	c
	and	$02
	jr	nz,.other

	call	GETKEY
	cp	$1b		; ESC
	jr	nz,.esc

		; other
.other:	ld	a,$03
	jr	.end

.n_esc:	call	SPACEDET
	jr	nz,.other

		; SPACE
	ld	a,$01

.end:	pop	bc
	or	a		;Cflag=0
	ret


;
; Q[L[ƃWCXeBbN̓͂̃}[W
;
; RETURN
; Areg  <= SPC SEL <- -> v ^ RUN SFT
; Creg  <= ($JOYBUF)̔] iÕf[^j
; Zflag <= STOP"0"
;
JOYKEY:
	ld	a,(JOYBUF)
	cpl
	ld	c,a
	push	bc

	ld	a,$0f
	out	($a0),a
	ld	a,$c0
	out	($a1),a		; JOYSTICK-1I

	ld	a,$0e
	out	($a0),a
	in	a,($a2)		; V  H  T2 T1 -> <- v  ^
	cpl
	and	$3f
	rlca			; 0  T2 T1 -> <- v  ^  0
	ld	b,a
	and	$10		; 0  0  0  -> 0  0  0  0
	ld	c,a

	rlc	b		; T2 T1 -> <- v  ^  0  0
	ld	a,b
	and	$0C		; 0  0  0  0  v  ^  0  0
	or	c		; 0  0  0 ->  v  ^  0  0
	ld	c,a

	rlc	b		; T1 -> <- v  ^  0  0 T2
	ld	a,b
	and	$a1		; T1 0  <- 0  0  0  0 T2
	or	c		; T1 0  <- -> v  ^  0 T2
	ld	b,a

	and	$0c
	cp	$0c
	jr	nz,.n_sel

	ld	a,b
	and	$f3
	or	$40
	ld	b,a

.n_sel:	ld	a,b
	and	$30
	cp	$30
	jr	nz,.n_run

	ld	a,b
	and	$cf
	or	$02
	ld	b,a

.n_run:	ld	a,(GAMEKEYBUF)	; SPC 0 <- -> v ^ STOP SFT
	ld	c,a
	and	$fd
	or	b
	ld	(JOYBUF),a

	bit	1,c	; STOP

.end:	pop	bc
	ret

JOYBUF:	db	$00



;
; CL[
;
; ESC:ESC܂Œ~
;     ̑̃L[Ɠl
;
; RETURN
; STOPF	Areg <= 0x00	Cflag=1,ZFlag=0
;
MAINKEYIN:
	ld	bc,MAINKEYRET	; ^[AhX
	push	bc

	call	GETKEY
	ld	d,a

	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	ld	b,a

	jr	z,.n_stop
	and	$01
	jr	z,.n_stop

		; SHIFT+STOP
	pop	bc
	scf			;Cflag=1
	ret

.n_stop:
	ld	a,c
	and	b
	and	$02
	jr	nz,.esc

	ld	a,d
	cp	$1b		; ESC
	jr	nz,.n_esc

.esc:	ld	a,$ff
	ld	(STOPFLAG),a

.loop:	call	GETKEY
	cp	$1b		; ESC
	jr	z,.esc2

	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	and	c
	and	$02
	jr	z,.loop

.esc2:	ld	a,$00
	ld	(STOPFLAG),a
	ret


.n_esc:
	ld	a,b
	call	SHOOT		; e۔ˏ

	ld	a,b
	and	$01
	jr	z,.shift

	ld	a,(SPBEF)
	or	a
	ld	a,(SPFLAG)
	jr	nz,.shift

	xor	$05
	ld	(SPFLAG),a

.shift:
	ld	(SPBEF),a
	push	bc
	push	de
	call	SPEED		; SPEEDUP/DOWNAԌ蕶̕\
	pop	de
	pop	bc

	ld	a,c
	and	b
	and	$40

	jp	nz,COMM		; ʐMVXe

	ld	a,d

	cp	'T'
	jp	z,COMM		; ʐMVXe

	cp	$f0		; F1
	jp	z,AUTOON	; 䑕uON

	cp	$f1		; F2
	jp	z,AUTOOFF	; 䑕uOFF

	cp	$f2		; F3
	jp	z,HREV		; ]

	cp	$f3		; F4
	jp	z,VREV		; ]

	cp	$f4		; F5
	jp	z,SOUNDSW	; SOUND ON/OFF؂ւ

	jp	MOVESHIP

MAINKEYRET:
	or	a
	ret


SPBEF:	db	$00
SPFLAG:	db	$04

;
; a̖O
;
; RETURN:Areg <= 0 -> SFT <- 0 0 0 0 ̔]
;
NAMEIN:
	ld	d,$ff
	call	SPACEDET
	jr	nz,.n_spc
	ld	d,$00
.n_spc;

	ld	a,(PORT00)
	cpl
	ld	c,a

	push	bc

	call	JOYKEY		; SPC SEL <- -> v ^ RUN SFT
	ld	b,a

	rrca
	and	$10		; 0 0 0 <- 0 0 0 0

	bit	0,b
	jr	z,.n_sft
	or	$20		; 0 0 SFT <- 0 0 0 0

.n_sft:	bit	4,b
	jr	z,.end
	or	$40		; 0 -> SFT <- 0 0 0 0

.end:	cpl
	pop	bc

	jp	NAMEENT


;
; a薼ÕZ[u
;
SCORESAVE:
	call	DISPNAME

	ld	hl,SCORETABLE
	ld	de,$f300
	ld	bc,10+16*5
	ldir

	ld	a,(GAMENO)
	add	a,$08
	ld	b,a
	ld	a,$ff
	call	SCLOADSAVE

	ret


;
; Ə\
;
DISPCROSS1:
	di
	ld	(DISPSP+1),sp
	jp	DISPCRSMAIN1


DISPCROSS2:
DISPSP:
	ld	sp,$0000	; ld	sp,DISPSP
	ei
	jp	DISPCRSMAIN2

;
; G@
;
ENEMY1:
	di
	ld	(ENESP+1),sp
	jp	ENEMYMAIN


ENEMY2:
ENESP:
	ld	sp,$0000	; ld	sp,ENESP
	ei

	pop	hl
	ret


;
; Sʔ]
;
DISPINV:
	push	hl
	push	de
	push	bc

	di
	ld	(DISPINVSP+1),sp

	ld	hl,(VRAM)	; VRAM擪AhX
	ld	de,160*2
	add	hl,de

	ld	a,h
	xor	$10
	ld	d,a
	ld	e,l

	ex	de,hl

	ld	sp,hl
	ld	bc,80*23

.loop:	pop	hl
	ld	a,l
	ld	(de),a
	inc	de
	ld	a,h
	xor	$77
	ld	(de),a
	inc	de

	dec	bc
	ld	a,b
	or	c
	jr	nz,.loop

DISPINVSP:
	ld	sp,$0000	; ld	sp,DISPINVSP
	ei

	pop	bc
	pop	de
	pop	hl

	call	CPAGEMAIN

	ld	b,$06
.loop:	call	VSYNCWAIT
	djnz	.loop

	call	CPAGEMAIN

	xor	a
	ld	(DISPINVFLAG),a
	ret



;
; [vpAgr[g̐ݒ
;
; HL <= ݒpf[^̊i[AhX
; DE <= Agr[gAhX
;
SETWPAT:
	push	bc
	ld	c,(hl)		; X1
	inc	hl
	inc	hl
	ld	a,(hl)		; X2

	bit	7,a
	jr	z,.dtcnt
	ld	a,80
.dtcnt:
	sub	c
	ld	b,a

	dec	hl
	ld	a,(hl)		; Ff[^
	inc	hl

	and	$e0
	rlca
	rlca
	rlca
	or	$88

.loop:
	ld	(de),a
	inc	de
	inc	de
	djnz	.loop

	pop	bc
	ret


;
; ʂ𖄂߂iRsځ`QSsځj
; A  <= ߂f[^
; HL <= VRAM擪AhX
;
WARPCLS:
	ld	de,160*2
	add	hl,de

	ld	d,a
	ld	bc,22*80

.loop:	ld	(hl),d
	inc	hl
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,.loop

	ret

;
; FςiRsځ`QSsځj
; HL <= VRAM擪AhX
;
WARPCH:
	ld	de,160*2+1
	add	hl,de

	ld	bc,22*80

;
; P8 G R B graph 1 0 0 0
;111
;110
;101
;100
;011
;010
;001
;000
;
; P6 graph 0 0 0 1 B G R
;111
;011
;110
;010
;101
;001
;100
;000

.loop:	ld	a,(hl)

	dec	a
	or	$88

	ld	(hl),a
	inc	hl
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,.loop

	ret

;
; VSYNC҂
;
VSYNCWAIT:
	push	bc
	ld	a,(VSYNCBUF)
	ld	b,a
.loop:	ld	a,(VSYNCBUF)
	cp	b
	jr	z,.loop

	pop	bc
	ret



;
; fUCi[pAgr[g̏
;
DEGATT:
	ld	hl,(VRAM)	; VRAM擪AhX

	ld	bc,80*19
	ld	d,$8f
.loop1:	inc	hl
	ld	(hl),d
	inc	hl
	dec	bc
	ld	a,b
	or	c
	jr	nz,.loop1

	ld	b,45
	ld	d,$0f
.loop2:	inc	hl
	ld	(hl),d
	inc	hl
	djnz	.loop2

	ld	b,80-45
	ld	d,$0d
.loop3:	inc	hl
	ld	(hl),d
	inc	hl
	djnz	.loop3

	ld	b,80
	ld	d,$8f
.loop4:	inc	hl
	ld	(hl),d
	inc	hl
	djnz	.loop4

	ld	b,80
	ld	d,$0f
.loop5:	inc	hl
	ld	(hl),d
	inc	hl
	djnz	.loop5

	ld	b,80*3
	ld	d,$8f
.loop6:	inc	hl
	ld	(hl),d
	inc	hl
	djnz	.loop6

	ret

;
; fUCi[p̐FύX
;
; P8 G R B graph 1 0 0 0
; P6 graph 0 0 0 1 B G R
;
DEGCOL:
	ld	a,e
	and	$e0
	rlca
	rlca		; B 0 0 0 0 0 G R
	bit	7,a
	jr	z,.blue0
	or	$04	; B 0 0 0 0 B G R
.blue0:	or 	$88	; 1 0 0 0 0 1 G R
	ld	e,a

	ld	a,d
	and	$e0
	rlca
	rlca		; B 0 0 0 0 0 G R
	bit	7,a
	jr	z,.blue1
	or	$04	; B 0 0 0 0 B G R
.blue1:	or 	$88	; 1 0 0 0 1 B G R
	ld	d,a

	ld	b,04
.loop1:	inc	hl
	ld	(hl),e		; 25`28
	inc	hl
	djnz	.loop1
	ld	b,04
.loop2:	inc	hl
	ld	(hl),d		; 29`32
	inc	hl
	djnz	.loop2
	ret

;
; fUCi[̃L[͂ɑ΂R}h
;
DEGCOM:
	call	BOXMOVE		; eL[i̊g^kjASHIFT{eL[ïړj
	call	BOXCHANGE	; tL[#0`8iԍ̕ύXj
	ld	a,(FULKEYDT)
	cp	$0d
	call	z,BOXMAKE	; RETiVjASHIFT+RETiRs[j
	cp	' '
	call	z,BOXNEXT	; SPACEi̔ԍ̏j

	ld	a,(JOYKEYDT)
	and	$01
	jr	z,.n_sft	; SHIFTĂȂꍇAWv

	ld	a,(BOXNO)	; ҏWΏۂ̔ԍ
	or	a
	jr	z,.n_zero	; ԍO̎AWv

	ld	a,(FULKEYDT)
	cp	'I'
	call	z,BOXINS	; SHIFT{"I"iꎞL̈̃f[^rɑ}jiOł͎sȂj
	cp	'D'
	call	z,BOXDEL	; SHIFT{"D"i݂̔f[^폜ĈꎞL̈ɓ]jiOł͎sȂj
	cp	'?'
	call	z,ZERODIS	; SHIFT{"?"i#0ҏWs\ɂjiOł͎sȂj
	cp	'+'
	call	z,ZEROENB	; SHIFT{"+"i#0ҏW\ɂjiOł͎sȂj

.n_zero:
	ld	a,(FULKEYDT)
	cp	'G'
	call	z,GETSHIP	; SHIFT{"G"iʂ̉FDf[^ҏWj
	cp	'P'
	call	z,PUTSHIP	; SHIFT{"P"iҏWf[^ށj
	cp	'L'
	call	z,LOADSHIP	; SHIFT{"L"if[^[hj
	cp	'S'
	call	z,SAVESHIP	; SHIFT{"S"if[^Z[uj
	cp	'C'
	call	z,CLEARSCORE	; SHIFT{"C"inCXRANAj
	cp	'H'
	call	z,SCORESHIP	; SHIFT{"H"i_ςj
	cp	'X'
	call	z,EXITDEG	; SHIFT{"X"iGfB^𔲂j
	cp	$0b
	call	z,INITSHIP	; SHIFT{HOMEiOȊOׂč폜j

.n_sft:
	ld	a,(FULKEYDT)
	cp	'C'
	call	z,CHANGECOL1	; "C"iFR[hPςj
	cp	'B'
	call	z,CHANGECOL2	; "B"iFR[hQςj
	cp	'M'
	call	z,CHANGEBLINK	; "M"i_ŎʂύXj

	call	CALCBOX		; ҏWp[ÑAhXZo
	ld	hl,$0005
	add	hl,de
	call	ENCCOL		; Ff[^GR[h
	ld	(hl),a

	ret

ZEROENB:
	ld	a,$ff
	db	$fe		; cp	$af
ZERODIS:
	xor	a
	ld	(ZEROCHGENB),a	; #0̕ύX\tO
	ret


;
; ʃf[^Z[u^[h̑O
;
DISKPRE:
	ld	(COMNUM),a
	cp	$04
	ret	c
	cp	$06
	ret	z
	ld	a,(FILENO)
	ld	(BCDNUM),a
	ret

;
; nCXRANAiOj
;
CLEARSCORE:
	ld	hl,STRHICLR
	call	DISPSTR
	ld	a,$07
	jr	DISKPRE

;
; fUCi[̓R}h
;
; Areg = 0x01FGET / 0x02FPUT / 0x03FPOINT / 0x04FLOAD / 0x05FSAVE / 0x07 : CLEARSCORE
;
DEGEXCOM:
	ld	b,a
	cp	$10
	jp	z,SPCWAIT
	cp	$11
	jp	z,YNWAIT
	cp	$08
	jp	z,.oversave
	cp	$04
	jr	nc,.disk

	ld	a,(FULKEYDT)
	cp	$0d		; RETURN
	jp	z,GETPUTSCORE
	cp	$1b		; ESC
	jp	z,COMEND
	cp	$5f		; DEL ($7F)
	jp	z,NUMDEL	; 폜

	sub	$30		; ȊO̓^[
	jr	c,.disp2
	cp	$0a
	jr	nc,.disp2

	ld	c,a
	call	NUMSET		; ͂Zbg

.disp2:
	ld	hl,(VRAM)	; VRAM擪AhX
	ld	de,160*19+58*2
	add	hl,de
	ld	a,(BCDNUM)
	call	DISPBCD

	ret

		; DISK LOAD/SAVE/SCORECLEAR
.disk:
	ld	a,(FULKEYDT)
	cp	$0d		; RETURN
	jr	z,.exec
	cp	$1b		; ESC
	jp	z,COMEND

	sub	$30		; ȊO̓^[
	jr	c,.disp1
	cp	$0a
	jr	nc,.disp1

	ld	(BCDNUM),a

.disp1:
	ld	hl,(VRAM)	; VRAM擪AhX
	ld	de,160*19+58*2
	add	hl,de
	ld	a,(BCDNUM)
	add	a,'0'
	ld	(hl),a
	ret

.exec:
	ld	c,b

	ld	a,(BCDNUM)
	and	$0f
	ld	(FILENO),a

	ld	a,c
	cp	$04
	jr	z,.load
	cp	$05
	jr	z,.save

.clear:
	ld	hl,STRCLRFILE
	call	DISPSTR

	ld	a,(FILENO)
	add	a,$08
	ld	b,a
	ld	a,$00
	call	SCLOADSAVEINIT
	jr	c,.io_err

	ld	a,(FILENO)
	add	a,$08
	ld	b,a
	ld	a,$ff
	call	SCLOADSAVE
	jr	c,.io_err

	jr	.read_hiscr		; I

.save:
	ld	hl,STRSAVEFILE	; "saving file..."
	call	DISPSTR

	ld	a,(FILENO)
	add	a,$08
	ld	b,a
	call	LOADHEAD
	jr	c,.io_err

	call	HEADCHECK
	jp	nz,OVWRITE	; ʃf[^ꍇA㏑mF

.oversave:
	ld	a,(FILENO)
	add	a,$08
	ld	b,a
	ld	a,$ff
	call	LOADSAVE	; ʃf[^Z[u
	jr	c,.io_err

	jp	COMEND		; I

.load:
	ld	hl,STRLOADFILE	; "loading file..."
	call	DISPSTR

	ld	a,(FILENO)
	add	a,$08
	ld	b,a
	call	LOADHEAD
	jr	c,.io_err

	call	HEADCHECK
	jr	z,.no_data

	ld	a,(FILENO)
	add	a,$08
	ld	b,a
	ld	a,$00
	call	LOADSAVE	; ʃf[^[h
	jr	c,.io_err

	ld	a,(FILENO)
	ld	(GAMENO),a

.read_hiscr:
		; nCXRAǂݍ
	ld	a,(GAMENO)
	add	a,$08
	ld	b,a
	ld	a,$00
	call	SCLOADSAVE		; nCXRAǂݍ
	jr	c,.io_err


	ld	hl,$f300
	ld	de,SCORETABLE
	ld	bc,10+16*5
	ldir

	jp	COMEND		; I


; ʃf[^Ȃꍇ
.no_data:
	ld	hl,STRNODATA
	jr	.no_io

; fBXNI/OG[
.io_err:
	ld	hl,STRIOERR

.no_io:
	call	DISPSTR

	ld	a,$10
	ld	(COMNUM),a
	ret

FILENO:	db	$00
GAMENO:	db	$00

;
; SPACEL[͑҂
;
SPCWAIT:
	ld	a,(FULKEYDT)
	cp	' '
	ret	nz

	jp	COMEND


;
; Y/NL[͑҂
;
YNWAIT:
	ld	a,(FULKEYDT)
	cp	'N'
	jp	z,COMEND
	cp	$1b		; ESC
	jp	z,COMEND
	cp	'Y'
	ret	nz

	ld	a,$08
	ld	(COMNUM),a
	ret


;
; ʃf[^邩ǂ̃`FbN
;
; RETURN:ʃf[^ȂꍇAZflag=1
;
HEADCHECK:
	push	bc
	ld	hl,$f300		; f[^擪
	ld	b,$10
	ld	a,$ff

.loop:	and	(hl)
	inc	hl
	djnz	.loop
	pop	bc

	cp	$ff
	ret



;
; ʃf[^̏㏑mF̕\
;
OVWRITE:
	ld	hl,STROVERWR
	call	DISPSTR

	ld	a,$11
	ld	(COMNUM),a

	ret



;
; L[̓f[^擾
;
; RETURN
; Areg:L[f[^
; f[^ȂAZflag=1
;
GETKEY:
	di
	push	hl
	ld	hl,KEYBUF
	ld	a,(hl)
	ld	(hl),$00
	or	a
	pop	hl
	ei
	ret


	org	$7fff
	db	$00		; $7FFF

	end
